﻿using UnityEngine;
using System.Collections;

public class BobbingMotion : MonoBehaviour {

	public float Ybob=0;
	public float Xbob=0;

	public float YcycleTime=2.3f;
	public float XcycleTime=2.3f;

	private Vector3 originalPos;
	private float startTime;

	private GameController gc;

	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();

		originalPos = transform.position;

		// adjust params randomly a bit, to prevent all instances of a bobbing prefab from being the same
		Xbob = Xbob + (Xbob*(float)gc.rand.NextDouble())/10f;
		Ybob = Ybob + (Ybob*(float)gc.rand.NextDouble())/10f;
		XcycleTime = XcycleTime + (XcycleTime*(float)gc.rand.NextDouble())/10f;
		YcycleTime = YcycleTime + (YcycleTime*(float)gc.rand.NextDouble())/10f;

		startTime = Time.time + YcycleTime*(float)gc.rand.NextDouble();  // start out of phase
	}
	
	// Update is called once per frame
	void FixedUpdate () {

		float xsaw = (((Time.time - startTime) % XcycleTime)/XcycleTime);
		float xsin = Mathf.Sin( xsaw*2*Mathf.PI);

		float ysaw = (((Time.time - startTime) % YcycleTime)/YcycleTime);
		float ysin = Mathf.Sin( ysaw*2*Mathf.PI);

		float xoff = Xbob * xsin;
		float yoff = Ybob * ysin;

		transform.position = new Vector3( originalPos.x + xoff, originalPos.y + yoff, originalPos.z);
	}
}
