﻿using UnityEngine;
using System.Collections;

public class BoundaryCollider : MonoBehaviour {

	public float BounceFactor;
	public float Knockback;
	public float StunTime;

	private GameController gc;
	
	
	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
	}
	

	void OnCollisionEnter2D(Collision2D coll) {
		if (coll.gameObject.tag == "Player")
		{
			float yvel = coll.rigidbody.velocity.y;

			Vector2 deltavel;

			if(coll.transform.position.y < transform.position.y)
				deltavel = new Vector2(0,-Knockback);
			else
				deltavel = new Vector2(0, Knockback);

			Vector2 force = coll.rigidbody.mass * deltavel / Time.fixedDeltaTime;

			Debug.Log ("Boundary applying force " + force + " to player with vel " + coll.rigidbody.velocity);
			coll.rigidbody.AddForce(force);

			// mark player as stunned
			PlayerMovementController moveCtrl = coll.gameObject.GetComponent<PlayerMovementController>();
			moveCtrl.Stun(StunTime);
			gc.PlaySound(gc.BoundaryBumpSound, 1.0f);
		}
		
	}
}
