﻿using UnityEngine;
using System.Collections;

public class CameraFollow : MonoBehaviour {

	public float PlayerBackset=6f;

	private Transform player;		// Reference to the player's transform.

	// Use this for initialization
	void Start () {
		// Setting up the reference.
		GameObject pgo = GameObject.FindWithTag("Player");
		if(pgo == null)
		{
			Debug.LogWarning("CameraFollow Warning: Unable to locate player game object on start.  Will attempt to find during update.");
			return;
		}
		player = pgo.transform;

	}
	
	// Update is called once per frame
	void Update () {
		if(player == null)
		{
			GameObject pgo = GameObject.FindWithTag("Player");
			if(pgo == null)
			{
				return;
			}
			player = pgo.transform;
		}

		transform.position =  new Vector3(player.position.x+PlayerBackset, 0, transform.position.z);

	}
}
