﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class LevelData {

	public int Level { get; set; }

	public float Length { get; set; }


	public bool Over { get; set; }
	public bool Victory { get; set; }
	public int AlienCount { get; set; }
	public int AliensCaptured { get; set; }
	public int ShipsWrecked { get; set; }

	public Vector2 StartPosition { get; set; }

	public List<WaveData> Waves { get; set; }


	public List<Transform> WaterLinePrefabs { get; set; }
	public Transform FloorPrefab;
	public Transform UnderwaterBasePrefab;
	public Transform UnderwaterOverlayPrefab;

	public List<Transform> TransformsForCleanup { get; set; }

	public LevelData(int level)
	{
		Level = level;
		TransformsForCleanup = new List<Transform>();
		Waves = new List<WaveData>();

		WaterLinePrefabs = new List<Transform>();
	}
}
