﻿using UnityEngine;
using System.Collections;

public class LevelInstantiator  {

	private GameController gc;
	
	public LevelInstantiator(GameController g)
	{
		gc = g;
	}

	public void InstantiateLevel(LevelData level)
	{
				
		// ADD YOUR LEVEL INSTANTIATION CODE HERE
		// read conceptual data in level and create transforms
		// make sure to add to LevelData.Transforms for cleanup later
	
		AddWaterLine(level);
		AddObstacleWaves(level);
		// now handled when placing water, so it lines up nicely:  AddFinishLine(level);
	}

	private void AddWaterLine(LevelData level)
	{
		float x = 0;

		while(x<level.Length)
		{
			int w = gc.rand.Next(0, level.WaterLinePrefabs.Count);
			Transform watPrefab = level.WaterLinePrefabs[w];

			Transform wat = (Transform) GameObject.Instantiate(watPrefab);
			level.TransformsForCleanup.Add (wat);

			wat.position = new Vector3(x, 0f, 0f);

			Transform underbase = (Transform) GameObject.Instantiate(level.UnderwaterBasePrefab);
			level.TransformsForCleanup.Add (underbase);
			underbase.position = new Vector3(x, -1.5f, 0f);

			Transform underbase2 = (Transform) GameObject.Instantiate(level.UnderwaterBasePrefab);
			level.TransformsForCleanup.Add (underbase2);
			underbase2.position = new Vector3(x, -4f, 0f);


			Transform floor = (Transform) GameObject.Instantiate(level.FloorPrefab);
			level.TransformsForCleanup.Add (floor);
			
			floor.position = new Vector3(x, -5.43f, 0f);

			Transform ceiling = (Transform) GameObject.Instantiate(level.FloorPrefab);
			level.TransformsForCleanup.Add (ceiling);
			
			ceiling.position = new Vector3(x, 6f, 0f);

			
			float size = wat.renderer.bounds.max.x - wat.renderer.bounds.min.x;

			x += size;
		}

		Transform finish = (Transform) GameObject.Instantiate(gc.FinishLinePrefab);  // move to gen like other gc-prefab reads?
		level.TransformsForCleanup.Add (finish);
		
		finish.position = new Vector3(x-2.3f, 0f, 0f);

	}

	private void AddObstacleWaves(LevelData level)
	{
		foreach(WaveData wave in level.Waves)
		{
			float xoff = 0;
			foreach(Transform ob in wave.ObstaclePrefabs)
			{
				float loc = wave.XLocation + xoff;

				Transform stacle = (Transform) GameObject.Instantiate(ob);
				level.TransformsForCleanup.Add (stacle);

				stacle.position = new Vector3(loc, -0.1f, 0f);

				xoff += wave.Spread + wave.Variance * (float)gc.rand.NextDouble();
			}

			foreach(Transform al in wave.AlienPrefabs)
			{
				float loc = wave.XLocation + (float)gc.rand.NextDouble()*xoff;
				
				Transform alien = (Transform) GameObject.Instantiate(al);
				level.TransformsForCleanup.Add (alien);
				
				alien.position = new Vector3(loc, 1f, 0f);
			}
		}
	}

	private void AddFinishLine(LevelData level)
	{
		
		Transform finish = (Transform) GameObject.Instantiate(gc.FinishLinePrefab);  // move to gen like other gc-prefab reads?
		level.TransformsForCleanup.Add (finish);
		
		finish.position = new Vector3(level.Length, 0f, 0f);
	}

}
