﻿using UnityEngine;
using System.Collections;

public class PlayerWaterJuiceCollider : MonoBehaviour {

	public JuiceDropper DripDropper;
	public JuiceDropper BubbleDropper;

	private float lastSplash;

	private GameController gc;
	
	
	// Use this for initialization
	void Start () {
		GameObject go = GameObject.Find ("GameController");
		gc = go.GetComponent<GameController>();
	}


	void OnTriggerEnter2D(Collider2D other) {
		if(Time.time - lastSplash < 0.4f)
			return;
		
		if (other.gameObject.tag == "WaterLine")
		{
			lastSplash = Time.time;

			if(rigidbody2D.velocity.y < 0)  // down into the water, bubbles
			{
				BubbleDropper.StartDropping();
				gc.PlayDownSplash();
			}
			else  // up is a drip
			{
				DripDropper.StartDropping();
				gc.PlayUpSplash();
			}

		}
	}
}
