﻿using UnityEngine;
using System.Collections;

public class SplashCollider : MonoBehaviour {

	public Transform SplashPrefab;

	private float lastSplash;

	// Use this for initialization
	void Start () {
	
	}

	void OnTriggerEnter2D(Collider2D other) {
		if(Time.time - lastSplash < 0.4f)
			return;

		if (other.gameObject.tag == "Player")
		{
			lastSplash = Time.time;

			// we do not add splash to level cleanup because we expect it better have a SelfDestructTimer 
			Transform splash = (Transform) GameObject.Instantiate(SplashPrefab);

			Vector3 p = other.transform.position;
			splash.position = new Vector3(p.x, 0.5f, p.z);
			Debug.Log ("SPLASH!  Player is at " + other.transform.position + " and splash is at " + splash.position);
		}	
	}

}
